/* See AutoFocus/doc/COPYING for copyright/licensing information. */
/* cestan@cs.ucsd.edu 12/07/2003 */

/* The compression functions build compressed unidimensional and
   multidimensional reports based on a cluster graph. */

#ifndef COMPRESSION_H
#define COMPRESSION_H

#include "clustergraph.h"

clgnlist* build_unidim_report(clustergraph* cg, unsigned dim, sint8 threshold);
/* Builds the list of nodes that are in the unidimensional report. The
   computation is based on counter 0 and counter 1 is used as an
   auxiliary variable (and reset to 0. */
clgnlist* build_multidim_report(clustergraph* cg, sint8 threshold,
				unsigned add_root=0);
/* Builds the list of nodes that are in the unidimensional report. The
   computation is based on counter 0 and counter 1 is used as an
   auxiliary variable (and reset to 0). Puts into counter 2 the
   expected traffic for each cluster in the report. If add_root is
   set, the result will contain the root of the lattice (the cluster
   represeting all traffic) even if compression would have allowed us
   to ommit it. This way you can force intermediate reports to contain
   the exact total traffic. */

#endif /* COMPRESSION_H */
