/* See AutoFocus/doc/COPYING for copyright/licensing information. */
/* cestan@cs.ucsd.edu 12/07/2003 */

/* Functions used for computing delta reports. Counter number 0 holds
   the current traffic and counter number 1 holds the traffic we
   compare against. */

#ifndef DELTA_H
#define DELTA_H

#include "clustergraph.h"

void normalizeclusterreports(clustergraph*cg);
/* Scales the counters for the traffic we compare against so that the
   total traffic we compare against is equal to the total current
   traffic. */

clgnlist* build_delta_report(clustergraph* cg, sint8 threshold);
/* A very slow algorithm that produces the compressed delta report. */

#endif /* DELTA_H */
