/* See AutoFocus/doc/COPYING for copyright/licensing information. */
/* cestan@cs.ucsd.edu 06/28/2002 */

#ifndef FHVC_H
#define FHVC_H

#include "../datatypes/record.h"
#include "../hash_map/hash_map.h"

void find_high_volume_clusters(record& flowID, hash_map& flow_memory,
			       uint8 threshold, hash_map& hvclusters,
			       unsigned offset=0);
/* flow_memory is indexed by keys described by flowID and the values
   associated with a key must start with an uint8 counter indicating
   the size of individual flows. hvclusters is indexed by keys
   described by the cluster associated with the flowID and should be
   empty when entering find_high_volume_clusters. Values have an uint8
   counter at position offset. On return hvclusters will contain all
   clusters above threshold and their traffic in the order of the top
   down traversal. */

#endif /* FHVC_H */
