/* See AutoFocus/doc/COPYING for copyright/licensing information. */
/* cestan@cs.ucsd.edu 06/26/2003 */

/* ofm stands one field memory. It aggregates the traffic along one
   field. From this data it can generate a traversal of the high
   volume patterns. Each field/pattern type need to implement their
   own ofm. */

#ifndef OFM_H
#define OFM_H

#include "ofh.h"
#include "../../datatypes/typedefs.h"

class ofm{
 public:
  virtual void newpacket(const byte* fvalue, uint8 increment=1)=0;
  /* Signals that a new packet (or flow) has arrived. The counter
     associated with the current value of the field is incremented by
     "increment". */
  virtual ofhorder* buildorderoflargepatterns(uint8 threshold)=0;
  /* Finds all patterns (unidimensional clusters) currently above the
     given threshold and builds the traversal order of the set of high
     volume unidimensional clusters. */
};

#endif /* OFM_H */
