/* See AutoFocus/doc/COPYING for copyright/licensing information. */
/* cestan@cs.ucsd.edu 07/10/2002 */

/* An atom is a simple thing that has one piece of information such as
   an IP address or a port range (unlike a flow identifier made up
   from 5 pieces of information). Each has a name it
   gets when it is created (e.g. source IP address). */

#ifndef ATOM_H
#define ATOM_H

#include "thing.h"

class atom: public thing{
 public:
  void prettyprint(buffer& b, const byte* data);
  void prettyprintname(buffer& b);
};

class atomwithname: public atom{
 public:
  atomwithname(const char* name){atomname=name;}
  void printname(buffer& b){b.print_string(atomname);}
 protected:
  const char* atomname;
};

#endif /* ATOM_H */
