/* See AutoFocus/doc/COPYING for copyright/licensing information. */
/* cestan@cs.ucsd.edu 07/29/2002 */

#include "cluster.h"

cluster::cluster(pattern*p0, pattern*p1, pattern*p2,
		 pattern*p3, pattern*p4, pattern*p5,
		 pattern*p6, pattern*p7, pattern*p8,
		 pattern*p9, pattern*p10, pattern*p11,
		 pattern*p12, pattern*p13, pattern*p14,
		 pattern*p15, pattern*p16, pattern*p17,
		 pattern*p18, pattern*p19):
    compound(p0,p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15,p16,p17,
	     p18,p19){
  foffsets[0]=0;
  for(int i=0;i<MAX_COMPOUND_SIZE;i++){
    if(things[i]!=NULL){
      foffsets[i+1]=foffsets[i]+getpattern(i).basefield().getbinsize();
    } else {
      foffsets[i+1]=foffsets[i];
    }
  }
}

int cluster::matches(const byte* cluster, const byte* record){
  for(int i=0;i<numthings;i++){
    if(!(getpattern(i).match(cluster+offsets[i],record+foffsets[i]))){
      return 0;
    }
  }
  return 1;
}

void cluster::setwildcards(byte* cluster){
  for(int i=0;i<numthings;i++){
    getpattern(i).setwildcard(cluster+offsets[i]);
  }
}

int cluster::compare(const byte* cluster1, const byte* cluster2){
  int second_always_includes_first=1;
  int first_always_includes_second=1;
  for(int i=0;i<numthings;i++){
    switch(getpattern(i).compare(cluster1+offsets[i],cluster2+offsets[i])){
    case P_UNRELATED:
      return C_NON_OVERLAPPING;
    case P_FIRST_INCLUDES_SECOND:
      second_always_includes_first=0;
      break;
    case P_SECOND_INCLUDES_FIRST:
      first_always_includes_second=0;
      break;
    }
  }
  if(first_always_includes_second){
    if(second_always_includes_first){
      return C_EQUAL;
    } else {
      return C_FIRST_INCLUDES_SECOND;
    }
  } else {
    if(second_always_includes_first){
      return C_SECOND_INCLUDES_FIRST;
    } else {
      return C_OVERLAPPING;
    }
  }
}

int cluster::comesfirst(const byte* cluster1, const byte* cluster2){
  int i;
  for(i=0;i<numthings && equals(cluster1+offsets[i],cluster2+offsets[i],
				    offsets[i+1]-offsets[i]) ;i++);
  if(i==numthings){ /* They are equal */
    return 0;
  }
  return getpattern(i).comesfirst(cluster1+offsets[i],cluster2+offsets[i]);
}

