/* See AutoFocus/doc/COPYING for copyright/licensing information. */
/* cestan@cs.ucsd.edu 07/29/2002 */

/* The cluster is a record that only contains patterns. */

#ifndef CLUSTER_H
#define CLUSTER_H

#include "compound.h"
#include "pattern.h"

#define C_EQUAL                  0
#define C_FIRST_INCLUDES_SECOND  1
#define C_SECOND_INCLUDES_FIRST  2
#define C_NON_OVERLAPPING        3
#define C_OVERLAPPING            4

class cluster: public compound{
 public:
  cluster(pattern*p0=NULL, pattern*p1=NULL, pattern*p2=NULL, pattern*p3=NULL,
	  pattern*p4=NULL, pattern*p5=NULL, pattern*p6=NULL, pattern*p7=NULL,
	  pattern*p8=NULL, pattern*p9=NULL, pattern*p10=NULL,
	  pattern*p11=NULL, pattern*p12=NULL, pattern*p13=NULL,
	  pattern*p14=NULL, pattern*p15=NULL, pattern*p16=NULL,
	  pattern*p17=NULL, pattern*p18=NULL, pattern*p19=NULL);
  int matches(const byte* cluster, const byte* record);
  /* Checks whether the record is in the cluster */
  void setwildcards(byte* cluster); /* sets all patterns to wildcards */
  int compare(const byte* cluster1, const byte* cluster2);
  /* Determines the relation between two clusters on the same fields */
  int comesfirst(const byte* cluster1, const byte* cluster2);
  /* Determines their position in the traversal of the cluster graph */
  pattern& getpattern(int index){return *(pattern*)things[index];}
  unsigned int getfoffset(int index){return foffsets[index];}
 protected:
  unsigned int foffsets[MAX_COMPOUND_SIZE+1];
  /* The offsets at which the values corresponding to each pattern
     start in a matched record. */
};

#endif /* CLUSTER_H */
