/* See AutoFocus/doc/COPYING for copyright/licensing information. */
/* cestan@cs.ucsd.edu 06/24/2003 */

#ifndef IPOFM_H
#define IPOFM_H

#include "../../algorithms/onefield/ofm.h"
#include "iporderhelper.h"
#include "../typedefs.h"
#include "../../hash_map/growing_hash.h"

class ipofm: public ofm{
 public:
  ipofm();
  void newpacket(const byte* fvalue, uint8 increment=1);
  ofhorder* buildorderoflargepatterns(uint8 threshold);
 private:
  growing_hash counters;
};

class ipofmorder: public iporderhelper{
 public:
  ipofmorder(growing_hash& counters, uint8 threshold);
};

#endif /* IPOFM_H */
