/* See AutoFocus/doc/COPYING for copyright/licensing information. */
/* cestan@cs.ucsd.edu 06/26/2003 */

/* This structure describes the values inside hash_maps used to build
   IP prefix orders. The helper class can convert the hash_map into
   the block the ofhorder needs. */

#ifndef IPOH_H
#define IPOH_H

#include "../../hash_map/growing_hash.h"
#include "../../algorithms/onefield/ofh.h"
#include "prefix.h"

typedef struct phm_entry{
  int parentindex;
  int pruneindex;
} pmh_entry; 

class iporderhelper: public ofhorder{
 public:
  iporderhelper():ofhorder(sizeof(prefixstruct)){;}
 protected:
  void convert_growing_hash(growing_hash & prefixes);
};

#endif /* IPOH_H */
