/* See AutoFocus/doc/COPYING for copyright/licensing information. */
/* cestan@cs.ucsd.edu 07/29/2002 */

/* This header describes the port range pattern. */

#ifndef PRANGE_H
#define PRANGE_H

#include "../pattern.h"

/* The internal binary representation of a port range */
#pragma pack(1)
struct prangestruct{
  uint2 min;
  uint2 max;
};
#pragma pack()

inline uint2& minpnum(const void* data){
  return ((prangestruct*)data)->min;}
inline uint2& maxpnum(const void* data){
  return ((prangestruct*)data)->max;}

class prange:public pattern{
 public:
  prange(class port& f){base_field=&f;}
  unsigned int getbinsize(){return sizeof(prangestruct);}
  unsigned int getmaxhrsize(){return 11;}
  void print(buffer& b, const byte* data);
  int parse(buffer& b, byte* data);
  int match(const byte* pdata, const byte* fdata);
  /* Does prange pdata match port fdata? */
  int isstar(const byte* data);
  void setwildcard(byte* data);
  /* Sets the pattern to "don't care" */
  void settoparent(const byte* child, byte* parent);
  field& basefield(){return *(field*)base_field;}
  int compare(const byte* data1, const byte* data2);
  int gethdepth(){return 3;}
  int getdepth(const byte* data);
  int comesfirst(const byte* p1, const byte* p2);
  class ofm* buildofm();
 private:
  class port* base_field;
};

#endif /* PRANGE_H */
