/* See AutoFocus/doc/COPYING for copyright/licensing information. */
/* cestan@cs.ucsd.edu 07/30/2002 */

#include <stdlib.h>
#include <string.h>
#include "protofm.h"
#include "protop.h"
#include "../../readwrite/assume.h"

protofm::protofm(){
  memset(counters,'\0',8*256);
}

void protofm::newpacket(const byte* fvalue, uint8 increment){
  counters[*fvalue]+=increment;
}

ofhorder* protofm::buildorderoflargepatterns(uint8 threshold){
  protofmorder* result =new protofmorder(counters,threshold);
  assumenotnull(result);
  return result;
}

protofmorder::protofmorder(uint8* counters,uint8 threshold):
  ofhorder(sizeof(protopstruct)){
  numpatterns=0;
  uint8 total=0;
  for(int i=0;i<256;i++){
    total+=counters[i];
    if(counters[i]>=threshold){
      numpatterns++;
    }
  }
  if(total>=threshold){
    numpatterns++;
  }
  if(numpatterns==0){
    patterns=NULL;
    return;
  }
  patterns=(ofhelement*)malloc(es*numpatterns);
  assumenotnull(patterns);
  ofhelement* done=nthpattern(numpatterns);
  patterns[0].parent=patterns;
  patterns[0].prune=done;
  iswcprotop(patterns[0].pattern)=1;
  protopnum(patterns[0].pattern)=0;
  ofhelement* crt=nthpattern(1);
  for(int i=0;i<256;i++){
    if(counters[i]>=threshold){
      crt->parent=patterns;
      crt->prune=(ofhelement*)((byte*)crt+es);
      iswcprotop(crt->pattern)=0;
      protopnum(crt->pattern)=i;
      crt=(ofhelement*)((byte*)crt+es);
    }
  }
}

