/* See AutoFocus/doc/COPYING for copyright/licensing information. */
/* cestan@cs.ucsd.edu 07/29/2002 */

#include "protop.h"
#include "proto.h"
#include "protofm.h"
#include "../../readwrite/assume.h"

void protop::print(buffer& b, const byte* data){
  if(iswcprotop(data)){
    b.print_char('*');
  } else {
    b.print_unsigned1(protopnum(data));
  }
}

int protop::parse(buffer& b, byte* data){
  if(b.parse_char('*')){
    iswcprotop(data)=1;
    protopnum(data)=0;
    return 1;
  }
  if(b.parse_unsigned1(&protopnum(data))){
    iswcprotop(data)=0;
    return 1;
  }
  return 0;
}

int protop::match(const byte* pdata, const byte* fdata){
  if(iswcprotop(pdata)){
    return 1;
  }
  return protopnum(pdata) == *fdata;
}

int protop::isstar(const byte* data){
  return iswcprotop(data);
}

void protop::setwildcard(byte* data){
  iswcprotop(data)=1;
  protopnum(data)=0;
}

void protop::settoparent(const byte* child, byte* parent){
  iswcprotop(parent)=1;
  protopnum(parent)=0;
}

int protop::compare(const byte* data1, const byte* data2){
  if(iswcprotop(data1)){
    if(iswcprotop(data2)){
      return P_EQUAL;
    } else {
      return P_FIRST_INCLUDES_SECOND;
    }
  } else {
    if(iswcprotop(data2)){
      return P_SECOND_INCLUDES_FIRST;
    } else {
      if(protopnum(data1)==protopnum(data2)){
	return P_EQUAL;
      } else {
	return P_UNRELATED;

      }
    }
  }
}

int protop::getdepth(const byte* data){
  if(iswcprotop(data)){
    return 0;
  } else {
    return 1;
  }
}

int protop::comesfirst(const byte* p1, const byte* p2){
  if(iswcprotop(p2)){
    return 0;
  }
  if(iswcprotop(p1)){
      return 1;
  }
  if(protopnum(p1)<protopnum(p2)){
    return 1;
  } else {
    return 0;
  }
}

ofm* protop::buildofm(){
  protofm* result =new protofm();
  assumenotnull(result);
  return result;
}
