/* See AutoFocus/doc/COPYING for copyright/licensing information. */
/* cestan@cs.ucsd.edu 07/29/2002 */

/* This header describes the protocol pattern. */

#ifndef PROTOP_H
#define PROTOP_H

#include "../pattern.h"

/* The internal binary representation of a protocol pattern */
#pragma pack (1)
struct protopstruct{
  uint1 proto;
  uint1 iswildcard;
};
#pragma pack ()

inline uint1& iswcprotop(const void* data){
  return ((protopstruct*)data)->iswildcard;}
inline uint1& protopnum(const void* data){
  return ((protopstruct*)data)->proto;}

class protop:public pattern{
 public:
  protop(class proto& f){base_field=&f;}
  unsigned int getbinsize(){return 2;}
  unsigned int getmaxhrsize(){return sizeof(protopstruct);}
  void print(buffer& b, const byte* data);
  int parse(buffer& b, byte* data);
  int match(const byte* pdata, const byte* fdata);
  /* Does protopattern pdata match protocol fdata? */
  int isstar(const byte* data);
  void setwildcard(byte* data);
  /* Sets the pattern to "don't care" */
  void settoparent(const byte* child, byte* parent);
  field& basefield(){return *(field*)base_field;}
  int compare(const byte* data1, const byte* data2);
  int gethdepth(){return 2;}
  int getdepth(const byte* data);
  int comesfirst(const byte* p1, const byte* p2);
  class ofm* buildofm();
 private:
  class proto* base_field;
};

#endif /* PROTOP_H */
