/* See AutoFocus/doc/COPYING for copyright/licensing information. */
/* cestan@cs.ucsd.edu 07/12/2002 */

/* This header describes the timestamp atom. Timestamps are stored on
   128 bits and count nanoseconds. */

#ifndef TIMESTAMP_H
#define TIMESTAMP_H

#include "atom.h"

class timestamp:public atomwithname{
 public:
  timestamp(char* name):atomwithname(name){;}
  unsigned int getbinsize(){return 8;}
  unsigned int getmaxhrsize(){return 21;}
  void print(buffer& b, const byte* data);
  int parse(buffer& b, byte* data);
  uint8 getseconds(const  byte* data)
    {return (*(uint8*)(data))/1000000000;}
  void setseconds(byte* data, uint8 seconds)
    {(*(uint8*)(data))=seconds*1000000000;}
  int isbefore(const byte* time1, const byte* time2)
    {return (*(uint8*)(time1))<(*(uint8*)(time2));}
};


#endif /* TIMESTAMP_H */
