/* See AutoFocus/doc/COPYING for copyright/licensing information. */
/* cestan@cs.ucsd.edu 07/31/2003 */

/* This program transforms the timestampless trace it gets on stdin
   into a list of flow records. */

#include "../datatypes/ip/ip.h"
#include "../datatypes/port/port.h"
#include "../datatypes/protocol/proto.h"
#include "../datatypes/compound.h"
#include "../datatypes/counter64.h"
#include "../readwrite/populate.h"
#include "../hash_map/growing_hash.h"

ip srcip("Source IP");
ip destip("Dest. IP");
port srcport("SrcP");
port destport("DestP");
proto protocol("Pro");
compound flowID(&srcip,&destip,&protocol,&srcport,&destport);
counter64 size("Size");
compound flowID_and_size(&srcip,&destip,&protocol,&srcport,&destport,&size);


int main(int argc,char* argv[]){
  uint8 numpackets=0;
  uint8 numbytes=0;
  int idlen=flowID.getbinsize();
  growing_hash flowtable(flowID.getbinsize(),16);
  read_plain("-",flowID,flowtable,AGGREGATION_SUM_AND_COUNT);
  buffer b;
  for(growing_hash_iterator i(flowtable);!i.at_end();++i){
    b.offset=0;
    flowID.print(b,i.key());
    b.print_char('\0');
    printf("%s\t%llu\t%llu\n",b.buff,*(uint8*)i.value(),*((uint8*)i.value()+1));
  }
}
