/* See AutoFocus/doc/COPYING for copyright/licensing information. */
/* cestan@cs.ucsd.edu 10/09/2003 */

/* The flowexportreader reads the output of flow-export -f2 (part of
   flow-tools) which is an ASCII format with one flow record on each
   line. Based on the file name, it detects whether it is compressed
   with gzip (extension .gz) and handles that case correctly. Data is
   read into the variables that describe the fields we care about in
   the flow record. The information returned in the byte array is:
   timestamp of first packet, timestamp of last packet, source IP
   address, destination IP address, protocol, source port, destination
   port, number of bytes in flow, number of packets in flow. */

#ifndef FLOWEXPORT_H
#define FLOWEXPORT_H

#include "buffer.h"
#include "basicfilereader.h"

class flowexportreader{
 public:
  flowexportreader(const char* filename, int dieonerror=1);
  /* The file name and the simple objects that make up the record */
  byte* getnextrecord();
  /* If there is a record to read returns its parsed contents */
  ~flowexportreader();
 private:
  byte* databuffer; /* The results go here. */
  basicfilereader f;
  const int dieonerror;
};

#endif /* FLOWEXPORT_H */
